//this file contains function definitions for new clientside commands

//when REGISTERING_CLIENT_COMMANDS is defined, that means that this
//file is being included in the middle of a function and should not
//include further headers
#ifndef REGISTERING_CLIENT_COMMANDS
#include <extdll.h>		//always
#include <string.h> //to prevent linux errors while processing meta_api.h
#include <meta_api.h>
#include <cbase.h>
#include <player.h>
//all those goddamn includes, just so we can access CBaseEntity
#endif

//DEFINE_CLIENT_COMMAND() Macro
//This macro can be defined in two different ways depending on whether the
//REGISTERING_CLIENT_COMMANDS macro is defined, if that macro is undefined 
//then DEFINE_CLIENT_COMMAND() will simply provide a forward declaration of the 
//function in the form void function(CBasePlayer *pPlayer), if the 
//REGISTERING_CLIENT_COMMANDS macro is defined then DEFINE_CLIENT_COMMAND() 
//will run the necessary code to detect if a client has typed the specified
//command and call the associated function
//
//Why you ask: This complex macro exists so that I can add a function to this
//one file and have it all setup and ready to go in every place that needs
//to do something to prepare it. In short: to centralize information

//START - DEFINE_CLIENT_COMMAND() Macro
#ifdef DEFINE_CLIENT_COMMAND
#undef DEFINE_CLIENT_COMMAND
#endif
#ifdef REGISTERING_CLIENT_COMMANDS
#define DEFINE_CLIENT_COMMAND(function) \
	if(FStrEq(szUserCommand, "" #function "")) { \
		function( (CBasePlayer *)GET_PRIVATE(pEntity) ); \
		return; \
	} else
#else
#define DEFINE_CLIENT_COMMAND(function) void function(CBasePlayer *pPlayer)
#endif
//END - DEFINE_CLIENT_COMMAND() Macro








//now that we have all the damn setup out of the way, here is where
//all the functions get defined



