//here should be the new versions of functions we receive

#include "hookedfunctions.h" //function definitions for this file
#include "clientcommands.h"

#include "plugin.h"
#include "utilfunctions.h"


int Spawn(edict_t *pEntity) {
	if (FStrEq(STRING(pEntity->v.classname), "worldspawn"))
	{
		DynamicSizedData.Initialize();
		RETURN_META_VALUE(MRES_HANDLED, 0);
	}

	RETURN_META_VALUE(MRES_IGNORED, 0);
}

/*void ClientCommand( edict_t *pEntity )
{
	const char* szUserCommand = CMD_ARGV(0);

//these next 3 lines will use the super duper DEFINE_CLIENT_COMMAND() macro to route each command to the appropriate function
#define REGISTERING_CLIENT_COMMANDS
#include "clientcommands.h"
#undef REGISTERING_CLIENT_COMMANDS

	RETURN_META(MRES_IGNORED);
}*/

BOOL ClientConnect( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  ) {
	int iPlayerNum = UTIL_GetPlayerIndex( (CBasePlayer *)GET_PRIVATE( pEntity ) );
	DynamicSizedData.fLastUseTime[iPlayerNum] = 0.0f;
	DynamicSizedData.iCarryingGorge[iPlayerNum] = 0;
	DynamicSizedData.iCarriedByLerk[iPlayerNum] = 0;
	for(int counter = 1; counter <= gpGlobals->maxClients; ++counter ) {
		if(DynamicSizedData.iCarryingGorge[counter] == iPlayerNum) DynamicSizedData.iCarryingGorge[counter] = 0;
		if(DynamicSizedData.iCarriedByLerk[counter] == iPlayerNum) DynamicSizedData.iCarriedByLerk[counter] = 0;
	}

	CLIENT_PRINTF( pEntity, print_console, "\n");
	CLIENT_PRINTF( pEntity, print_console, "LerkLift MetaMod Plugin version ");
	CLIENT_PRINTF( pEntity, print_console, MY_VERSION);
	CLIENT_PRINTF( pEntity, print_console, "                ");
	CLIENT_PRINTF( pEntity, print_console, MY_DATE);
	CLIENT_PRINTF( pEntity, print_console, "\n");
	CLIENT_PRINTF( pEntity, print_console,"By: Dave Kircher/[WHO]Them with portions ripped from Hullu's Unstuck Pro\n");

	RETURN_META_VALUE(MRES_HANDLED, true);
}

void ClientDisconnect( edict_t *pEntity ) {
	int iPlayerNum = UTIL_GetPlayerIndex( (CBasePlayer *)GET_PRIVATE( pEntity ) );
	DynamicSizedData.fLastUseTime[iPlayerNum] = 0.0f;
	DynamicSizedData.iCarryingGorge[iPlayerNum] = 0;
	DynamicSizedData.iCarriedByLerk[iPlayerNum] = 0;
	for(int counter = 1; counter <= gpGlobals->maxClients; ++counter ) {
		if(DynamicSizedData.iCarryingGorge[counter] == iPlayerNum) DynamicSizedData.iCarryingGorge[counter] = 0;
		if(DynamicSizedData.iCarriedByLerk[counter] == iPlayerNum) DynamicSizedData.iCarriedByLerk[counter] = 0;
	}
	RETURN_META(MRES_HANDLED);
}

/*void ClientKill( edict_t *pEntity ) {
	int iPlayerNum = UTIL_GetPlayerIndex( (CBasePlayer *)GET_PRIVATE( pEntity ) );
	DynamicSizedData.iCarryingGorge[iPlayerNum] = 0;
	DynamicSizedData.iCarriedByLerk[iPlayerNum] = 0;
	for(int counter = 1; counter <= gpGlobals->maxClients; ++counter ) {
		if(DynamicSizedData.iCarryingGorge[counter] == iPlayerNum) DynamicSizedData.iCarryingGorge[counter] = 0;
		if(DynamicSizedData.iCarriedByLerk[counter] == iPlayerNum) DynamicSizedData.iCarriedByLerk[counter] = 0;
	}
	RETURN_META(MRES_HANDLED);
}*/

void StartFrame( void ) {
	int counter;

	CBasePlayer *pPlayer;

	for(counter = 1; counter <= gpGlobals->maxClients; ++counter) {
		pPlayer = (CBasePlayer *)UTIL_PlayerByIndex( counter );
		if(pPlayer != NULL) {
			// Fixed by mahnsawce
			if( (pPlayer->pev->button & IN_USE) && FStrEq(STRING(pPlayer->pev->model), "models/player/alien3/alien3.mdl" )) {
				//player is a lerk using stuff

				//now, we need to check this against the last detection time for this player to prevent overdetection
				if( ABSOLUTE_VALUE_EASY( gpGlobals->time - DynamicSizedData.fLastUseTime[counter] ) < 1.0f) continue; //this will make it so "use" only goes past this line once per second per player
				DynamicSizedData.fLastUseTime[counter] = gpGlobals->time;

				//if we're this far, this is a new usage of the use key for this second in the game

				if( DynamicSizedData.iCarryingGorge[counter] == 0 ) {
					//player is not carrying a gorge, try to pick one up
					CBaseEntity *pEntity = FindEntityForward( pPlayer );
					if(pEntity == NULL) continue;
					// Fixed by mahnsawce
					if(FStrEq(STRING(pEntity->pev->model), "models/player/alien2/alien2.mdl" )) {
						//the returned entity IS a gorge

						if(pPlayer->pev->team != pEntity->pev->team) continue; //gorge wasn't on the same team
						
						Vector vDistance = pPlayer->pev->origin - pEntity->pev->origin;
						// Fixed by mahnsawce
						// Visual studio .NET is stupid, and only lets sqrt on floats, long doubles, and doubles.
						if(sqrt( (float)(vDistance.x * vDistance.x) +
									  (vDistance.y * vDistance.y) +
									  (vDistance.z * vDistance.z) ) > 200.0) continue; //gorge is too far away to pickup

						// get index player number, this should be the index of the gorge were grabbing
						int iPlayerNum = UTIL_GetPlayerIndex( (CBasePlayer *)GET_PRIVATE( pEntity->edict() ) );
						// set this lerk as carrying this gorge
						DynamicSizedData.iCarryingGorge[counter] = iPlayerNum;
						// set this gorge as being carried by this lerk
						DynamicSizedData.iCarriedByLerk[iPlayerNum] = counter;
						
						//set any flags on the gorge or lerk that we need to succeed in carrying the stupid thing
						
						pEntity->pev->solid = SOLID_NOT;
						//pEntity->pev->movetype = MOVETYPE_NOCLIP;
					}
				}
				else {
					//player is carrying a gorge, drop it
					CBaseEntity *pEntity = UTIL_PlayerByIndex( DynamicSizedData.iCarryingGorge[counter] );

					UTIL_PutPlayerInOpenSpace( (CBasePlayer *)pEntity );

					//end gorge dropping code, clean up
					DynamicSizedData.iCarriedByLerk[DynamicSizedData.iCarryingGorge[counter]] = 0;
					DynamicSizedData.iCarryingGorge[counter] = 0;
					pEntity->pev->solid = SOLID_SLIDEBOX;
					//pEntity->pev->movetype = MOVETYPE_WALK;
				}
			}
			else if(DynamicSizedData.iCarriedByLerk[counter]) { //cheap and easy hack to detect if this is a gorge being carried
				// Fixed by mahnsawce
				if(!FStrEq(STRING(pPlayer->pev->model), "models/player/alien2/alien2.mdl" )) {
					//player is no longer a gorge
					
					UTIL_PutPlayerInOpenSpace( pPlayer );

					//end gorge dropping code, clean up
					DynamicSizedData.iCarryingGorge[DynamicSizedData.iCarriedByLerk[counter]] = 0;
					DynamicSizedData.iCarriedByLerk[counter] = 0;
					pPlayer->pev->solid = SOLID_SLIDEBOX;
					//pPlayer->pev->movetype = MOVETYPE_WALK;
				}
				else if(pPlayer->pev->button & IN_USE) {
					//gorge wants to drop
					UTIL_PutPlayerInOpenSpace( pPlayer );

					//end gorge dropping code, clean up
					DynamicSizedData.iCarryingGorge[DynamicSizedData.iCarriedByLerk[counter]] = 0;
					DynamicSizedData.iCarriedByLerk[counter] = 0;
					pPlayer->pev->solid = SOLID_SLIDEBOX;
					//pPlayer->pev->movetype = MOVETYPE_WALK;
				}
				else {
					//player is still a gorge and still wants to be carried
					CBaseEntity *pLerk = UTIL_PlayerByIndex( DynamicSizedData.iCarriedByLerk[counter] );

					if((pPlayer->pev->team != pLerk->pev->team)) { //fix readyroom bugs
						UTIL_PutPlayerInOpenSpace( (CBasePlayer *)pPlayer );
						DynamicSizedData.iCarryingGorge[DynamicSizedData.iCarriedByLerk[counter]] = 0;
						DynamicSizedData.iCarriedByLerk[counter] = 0;
						pPlayer->pev->solid = SOLID_SLIDEBOX;
						continue;
					}

					if( pPlayer->pev->deadflag | pLerk->pev->deadflag ) { //one of the players died
						UTIL_PutPlayerInOpenSpace( (CBasePlayer *)pPlayer );
						DynamicSizedData.iCarryingGorge[DynamicSizedData.iCarriedByLerk[counter]] = 0;
						DynamicSizedData.iCarriedByLerk[counter] = 0;
						pPlayer->pev->solid = SOLID_SLIDEBOX;
						continue;
					}
					// Fixed by mahnsawce
					if(!FStrEq(STRING(pLerk->pev->model), "models/player/alien3/alien3.mdl")) { //lerk is no longer a lerk
						UTIL_PutPlayerInOpenSpace( (CBasePlayer *)pPlayer );
						DynamicSizedData.iCarryingGorge[DynamicSizedData.iCarriedByLerk[counter]] = 0;
						DynamicSizedData.iCarriedByLerk[counter] = 0;
						pPlayer->pev->solid = SOLID_SLIDEBOX;
						continue;	
					}


					//update position
					pPlayer->pev->origin = pLerk->pev->origin;
					pPlayer->pev->velocity = pLerk->pev->velocity;
					pPlayer->pev->avelocity = pLerk->pev->avelocity;
				}
			}
		}
	}
	RETURN_META(MRES_IGNORED);
}



